(begin
  (define (factorial n)
    (if (> n 1)
        (* n (factorial (- n 1)))
        1))
  (factorial 10))


(begin
  (define (factorial n continue)
    (define (continuation p)
      (continue (* n p)))
    (if (> n 1)
        (factorial (- n 1) continuation)
        (continue 1)) )
  (factorial 10 display))


(newline)

(begin
  (define (continuation p closure)
    (let* ((n (car closure))
           (continuation (cadr closure))
           (nested-closure (caddr closure)))
      (continuation (* n p) nested-closure)))

  (define (factorial . closure)
    (define n (car closure))
    (define nested-continuation (cadr closure))
    (define nested-closure (caddr closure))
    (if (> n 1)
        (factorial (- n 1) continuation closure)
        (nested-continuation 1 nested-closure)))
 
  (define (top-continuation p closure)
    (display p))

  (factorial 10 top-continuation '()))